diff --git a/tools/kvm/Makefile b/tools/kvm/Makefile
index 5ec222f..7f1b1c5 100644
--- a/tools/kvm/Makefile
+++ b/tools/kvm/Makefile
@@ -20,6 +20,13 @@ TAGS	:= ctags
 
 PROGRAM	:= kvm
 
+OBJS	+= builtin-balloon.o
+OBJS	+= builtin-debug.o
+OBJS	+= builtin-help.o
+OBJS	+= builtin-list.o
+OBJS	+= builtin-pause.o
+OBJS	+= builtin-run.o
+OBJS	+= builtin-version.o
 OBJS	+= cpuid.o
 OBJS	+= disk/core.o
 OBJS	+= framebuffer.o
@@ -55,13 +62,6 @@ OBJS	+= uip/udp.o
 OBJS	+= uip/buf.o
 OBJS	+= uip/csum.o
 OBJS	+= kvm-cmd.o
-OBJS	+= kvm-debug.o
-OBJS	+= kvm-help.o
-OBJS	+= kvm-pause.o
-OBJS	+= kvm-balloon.o
-OBJS	+= kvm-list.o
-OBJS	+= kvm-run.o
-OBJS	+= kvm-version.o
 OBJS	+= mptable.o
 OBJS	+= rbtree.o
 OBJS	+= threadpool.o
@@ -167,8 +167,8 @@ $(DEPS):
 %.d: %.c
 	$(Q) $(CC) -M -MT $(patsubst %.d,%.o,$@) $(CFLAGS) $< -o $@
 
-# The header file common-cmds.h is needed for compilation of kvm-help.c.
-kvm-help.d: $(KVM_INCLUDE)/common-cmds.h
+# The header file common-cmds.h is needed for compilation of builtin-help.c.
+builtin-help.d: $(KVM_INCLUDE)/common-cmds.h
 
 $(OBJS):
 
diff --git a/tools/kvm/kvm-balloon.c b/tools/kvm/builtin-balloon.c
similarity index 95%
rename from tools/kvm/kvm-balloon.c
rename to tools/kvm/builtin-balloon.c
index 277cada..319941d 100644
--- a/tools/kvm/kvm-balloon.c
+++ b/tools/kvm/builtin-balloon.c
@@ -4,7 +4,7 @@
 
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-balloon.h>
+#include <kvm/builtin-balloon.h>
 #include <kvm/kvm.h>
 
 int kvm_cmd_balloon(int argc, const char **argv, const char *prefix)
diff --git a/tools/kvm/kvm-debug.c b/tools/kvm/builtin-debug.c
similarity index 94%
rename from tools/kvm/kvm-debug.c
rename to tools/kvm/builtin-debug.c
index 676f311..153badd 100644
--- a/tools/kvm/kvm-debug.c
+++ b/tools/kvm/builtin-debug.c
@@ -1,6 +1,6 @@
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-debug.h>
+#include <kvm/builtin-debug.h>
 #include <kvm/kvm.h>
 
 #include <stdio.h>
diff --git a/tools/kvm/kvm-help.c b/tools/kvm/builtin-help.c
similarity index 97%
rename from tools/kvm/kvm-help.c
rename to tools/kvm/builtin-help.c
index 817e4f8..e89cd5c 100644
--- a/tools/kvm/kvm-help.c
+++ b/tools/kvm/builtin-help.c
@@ -6,7 +6,7 @@
 
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-help.h>
+#include <kvm/builtin-help.h>
 
 
 const char kvm_usage_string[] =
diff --git a/tools/kvm/kvm-list.c b/tools/kvm/builtin-list.c
similarity index 96%
rename from tools/kvm/kvm-list.c
rename to tools/kvm/builtin-list.c
index 40c0e48..dde3fb3 100644
--- a/tools/kvm/kvm-list.c
+++ b/tools/kvm/builtin-list.c
@@ -1,6 +1,6 @@
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-list.h>
+#include <kvm/builtin-list.h>
 #include <kvm/kvm.h>
 
 #include <stdio.h>
diff --git a/tools/kvm/kvm-pause.c b/tools/kvm/builtin-pause.c
similarity index 94%
rename from tools/kvm/kvm-pause.c
rename to tools/kvm/builtin-pause.c
index ea4f95d..0c0010d 100644
--- a/tools/kvm/kvm-pause.c
+++ b/tools/kvm/builtin-pause.c
@@ -4,7 +4,7 @@
 
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-pause.h>
+#include <kvm/builtin-pause.h>
 #include <kvm/kvm.h>
 
 static void do_pause(const char *name, int pid)
diff --git a/tools/kvm/kvm-run.c b/tools/kvm/builtin-run.c
similarity index 99%
rename from tools/kvm/kvm-run.c
rename to tools/kvm/builtin-run.c
index 048b6a2..09bd1da 100644
--- a/tools/kvm/kvm-run.c
+++ b/tools/kvm/builtin-run.c
@@ -37,7 +37,7 @@
 #include <kvm/framebuffer.h>
 
 /* header files for gitish interface  */
-#include <kvm/kvm-run.h>
+#include <kvm/builtin-run.h>
 #include <kvm/parse-options.h>
 #include <kvm/mutex.h>
 
diff --git a/tools/kvm/kvm-version.c b/tools/kvm/builtin-version.c
similarity index 88%
rename from tools/kvm/kvm-version.c
rename to tools/kvm/builtin-version.c
index e30f74c..5b3b598 100644
--- a/tools/kvm/kvm-version.c
+++ b/tools/kvm/builtin-version.c
@@ -1,6 +1,6 @@
 #include <kvm/util.h>
 #include <kvm/kvm-cmd.h>
-#include <kvm/kvm-version.h>
+#include <kvm/builtin-version.h>
 #include <kvm/kvm.h>
 
 #include <stdio.h>
diff --git a/tools/kvm/include/kvm/kvm-balloon.h b/tools/kvm/include/kvm/builtin-balloon.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-balloon.h
rename to tools/kvm/include/kvm/builtin-balloon.h
diff --git a/tools/kvm/include/kvm/kvm-debug.h b/tools/kvm/include/kvm/builtin-debug.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-debug.h
rename to tools/kvm/include/kvm/builtin-debug.h
diff --git a/tools/kvm/include/kvm/kvm-help.h b/tools/kvm/include/kvm/builtin-help.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-help.h
rename to tools/kvm/include/kvm/builtin-help.h
diff --git a/tools/kvm/include/kvm/kvm-list.h b/tools/kvm/include/kvm/builtin-list.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-list.h
rename to tools/kvm/include/kvm/builtin-list.h
diff --git a/tools/kvm/include/kvm/kvm-pause.h b/tools/kvm/include/kvm/builtin-pause.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-pause.h
rename to tools/kvm/include/kvm/builtin-pause.h
diff --git a/tools/kvm/include/kvm/kvm-run.h b/tools/kvm/include/kvm/builtin-run.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-run.h
rename to tools/kvm/include/kvm/builtin-run.h
diff --git a/tools/kvm/include/kvm/kvm-version.h b/tools/kvm/include/kvm/builtin-version.h
similarity index 100%
rename from tools/kvm/include/kvm/kvm-version.h
rename to tools/kvm/include/kvm/builtin-version.h
diff --git a/tools/kvm/kvm-cmd.c b/tools/kvm/kvm-cmd.c
index 404065b..a954a61 100644
--- a/tools/kvm/kvm-cmd.c
+++ b/tools/kvm/kvm-cmd.c
@@ -5,14 +5,14 @@
 #include <assert.h>
 
 /* user defined header files */
-#include "kvm/kvm-debug.h"
-#include "kvm/kvm-pause.h"
-#include "kvm/kvm-balloon.h"
-#include "kvm/kvm-list.h"
-#include "kvm/kvm-version.h"
-#include "kvm/kvm-help.h"
+#include "kvm/builtin-debug.h"
+#include "kvm/builtin-pause.h"
+#include "kvm/builtin-balloon.h"
+#include "kvm/builtin-list.h"
+#include "kvm/builtin-version.h"
+#include "kvm/builtin-help.h"
 #include "kvm/kvm-cmd.h"
-#include "kvm/kvm-run.h"
+#include "kvm/builtin-run.h"
 
 struct cmd_struct kvm_commands[] = {
 	{ "pause",	kvm_cmd_pause,		NULL,         0 },